#line 1 "C:/Users/smilinkovic/Documents/Nauka/Projekti/Mikroelektronika/RTOS/Demo/CORTEX_STM32F107_MikroC/calculator_events_code.c"
#line 1 "c:/users/smilinkovic/documents/nauka/projekti/mikroelektronika/rtos/demo/cortex_stm32f107_mikroc/calculator_objects.h"
enum GlcdColor {_clClear, _clDraw, _clInvert};

typedef struct Screen TScreen;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
};

extern TScreen Screen1;
extern TButton Button19;
extern TButton Button1;
extern TButton Button5;
extern TButton Button6;
extern TButton Button7;
extern TButton Button2;
extern TButton Button3;
extern TButton Button4;
extern TButton Button8;
extern TButton Button9;
extern TButton Button10;
extern TButton Button12;
extern TButton Button13;
extern TButton Button14;
extern TButton Button15;
extern TBox Box3;
extern TButton Button16;
extern TButton Button17;
extern TButton Button18;
extern TBox Box1;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TLabel Label4;
extern TLabel Label5;
extern TLabel Label6;
extern TButton_Round ButtonRound2;
extern TButton * const code Screen1_Buttons[18];
extern TButton_Round * const code Screen1_Buttons_Round[1];
extern TLabel * const code Screen1_Labels[6];
extern TBox * const code Screen1_Boxes[2];


extern TScreen Screen2;
extern TLabel Label7;
extern TLabel Label8;
extern TButton_Round ButtonRound1;
extern TLabel Label9;
extern TLabel Label10;
extern TButton_Round * const code Screen2_Buttons_Round[1];
extern TLabel * const code Screen2_Labels[4];





void Button19Click();
void Button1Click();
void Button5Click();
void Button6Click();
void Button7Click();
void Button2Click();
void Button3Click();
void Button4Click();
void Button8Click();
void Button9Click();
void Button10Click();
void Button12Click();
void Button13Click();
void Button14Click();
void Button15Click();
void Button16Click();
void Button17Click();
void Button18Click();
void ButtonRound2Click();
void ButtonRound1Click();




extern char Button19_Caption[];
extern char Button1_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button8_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Button12_Caption[];
extern char Button13_Caption[];
extern char Button14_Caption[];
extern char Button15_Caption[];
extern char Button16_Caption[];
extern char Button17_Caption[];
extern char Button18_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char ButtonRound2_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char ButtonRound1_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawBox(TBox *ABox);
void Check_TP();
void Start_TP();
#line 1 "c:/users/smilinkovic/documents/nauka/projekti/mikroelektronika/rtos/demo/cortex_stm32f107_mikroc/calculator_resources.h"
const code char Arial16x19_Bold[];
const code char Arial21x24_Bold[];
const code char Courier_New12x23_Bold[];
const code char Tahoma11x13_Regular[];
const code char Tahoma13x13_Bold[];
const code char Tahoma13x16_Regular[];
#line 5 "C:/Users/smilinkovic/Documents/Nauka/Projekti/Mikroelektronika/RTOS/Demo/CORTEX_STM32F107_MikroC/calculator_events_code.c"
TLabel *label_selected;
char temp_label[20];

void ClearLbl( TLabel *_label) {
 TFT_Set_Font(_label->FontName, Box3.Color, FO_HORIZONTAL);
 TFT_Write_Text(_label->Caption, _label->Left, _label->Top);
}

void DrawLbl( TLabel *_label) {
 TFT_Set_Font(_label->FontName, _label->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text(_label->Caption, _label->Left, _label->Top);
}

void ClearLabel( TLabel *_label) {
 ClearLbl(_label);
 strcpy(_label->Caption, " ");
}

void ClearLabels() {
 label_selected = &Label1;
 ClearLabel(&Label1);
 ClearLabel(&Label2);
 ClearLabel(&Label3);
 ClearLabel(&Label6);
}

void Set_Defaults() {
 ClearLabels();
}




void Button16Click() {
unsigned int count;
unsigned int result;


 count = strlen(label_selected->Caption);
 if (count > 1) {
 if (label_selected == &Label1) {
 strcpy(temp_label, Label1_Caption);
 ClearLbl(&Label1);
 temp_label[count-1] = 0;
 strcpy(Label1_Caption, temp_label);
 DrawLbl(&Label1);
 }
 else
 if (label_selected == &Label2) {
 strcpy(temp_label, Label2_Caption);
 ClearLbl(&Label2);
 temp_label[count-1] = 0;
 strcpy(Label2_Caption, temp_label);
 DrawLbl(&Label2);
 }
 else
 if (label_selected == &Label3) {
 strcpy(temp_label, Label3_Caption);
 ClearLbl(&Label3);
 temp_label[count-1] = 0;
 strcpy(Label3_Caption, temp_label);
 DrawLbl(&Label3);
 }
 }
 else {
 if (label_selected == &Label1) {
 strcpy(Label1_Caption, " ");
 DrawLbl(&Label1);
 }
 else
 if (label_selected == &Label2) {
 strcpy(Label2_Caption, " ");
 DrawLbl(&Label2);
 label_selected = &Label1;
 }
 else
 if (label_selected == &Label3) {
 strcpy(Label3_Caption, " ");
 DrawLbl(&Label3);
 label_selected = &Label2;
 }
 }
}

void Button17Click() {

 ClearLabels();
}

void Button12Click() {

 ClearLabel(&Label2);
 label_selected = &Label2;
 strcpy(label_selected->Caption, " /");
 DrawLbl(label_selected);
 label_selected = &Label3;
}

void Button13Click() {

 ClearLabel(&Label2);
 label_selected = &Label2;
 strcpy(label_selected->Caption, " *");
 DrawLbl(label_selected);
 label_selected = &Label3;
}

void Button19Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "7");
 DrawLbl(label_selected);
 }
}

void Button7Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "8");
 DrawLbl(label_selected);
 }
}

void Button8Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "9");
 DrawLbl(label_selected);
 }
}

void Button14Click() {

 ClearLabel(&Label2);
 label_selected = &Label2;
 strcpy(label_selected->Caption, " -");
 DrawLbl(label_selected);
 label_selected = &Label3;
}

void Button1Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "4");
 DrawLbl(label_selected);
 }
}

void Button2Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "5");
 DrawLbl(label_selected);
 }
}

void Button9Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "6");
 DrawLbl(label_selected);
 }
}

void Button15Click() {

 ClearLabel(&Label2);
 label_selected = &Label2;
 strcpy(label_selected->Caption, " +");
 DrawLbl(label_selected);
 label_selected = &Label3;
}

void Button5Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "1");
 DrawLbl(label_selected);
 }
}

void Button3Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "2");
 DrawLbl(label_selected);
 }
}

void Button10Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "3");
 DrawLbl(label_selected);
 }
}

void Button6Click() {

 if (label_selected != 0) {
 ClearLbl(label_selected);
 strcat(label_selected->Caption, "0");
 DrawLbl(label_selected);
 }
}

void Button4Click() {
char temp[20] = " -";

 if ((label_selected != 0) && (label_selected != &Label2)) {
 strcpy(temp_label, label_selected->Caption);
 Ltrim(temp_label);
 switch (temp_label[0]) {
 case '-' : {
 temp_label[0] = ' ';
 break;
 }
 default : {
 strcat(temp, temp_label);
 strcpy(temp_label, temp);
 break;
 }
 }

 ClearLbl(label_selected);
 strcpy(label_selected->Caption, temp_label);
 DrawLbl(label_selected);
 }
}

void Button18Click() {

int first_operand, second_operand;
float result;
char first_operand_str[6];
char second_operand_str[6];
unsigned short counter, i;
char temp[5] = " ";


 first_operand = 0;
 second_operand = 0;
 i = 0;
 for (counter = 1; counter < 7; counter++) {
 first_operand_str[i] = Label1_Caption[counter];
 second_operand_str[i] = Label3_Caption[counter];
 i++;
 }

 first_operand = atoi(first_operand_str);
 second_operand = atoi(second_operand_str);
 ClearLbl(&Label6);
 strcpy(temp_label, Label2.Caption);
 Ltrim(temp_label);

 switch (temp_label[0]) {
 case '+' : {
 result = first_operand + second_operand;
 IntToStr((int)ceil(result), Label6_Caption);
 break;
 }
 case '-' : {
 result = first_operand - second_operand;
 IntToStr((int)ceil(result), Label6_Caption);
 break;
 }
 case '*' : {
 result = (float)first_operand * second_operand;
 IntToStr((int)ceil(result), Label6_Caption);
 break;
 }
 case '/': {
 result = (float)first_operand / second_operand;
 FloatToStr(result, Label6_Caption);
 break;
 }
 }
 DrawLbl(&Label6);
}

void ButtonRound1Click() {
 DrawScreen(&Screen1);
 Set_Defaults();
}

void ButtonRound2Click() {
 ClearLabels();
 DrawScreen(&Screen2);
}
